#include <linux/module.h>
#include <linux/init.h>
#include <linux/netdevice.h>

int test_pack_rcv( struct sk_buff *skb, struct net_device *dev,
                   struct packet_type *pt, struct net_device *odev ) {
   printk( KERN_INFO "packet received with length: %u\n", skb->len );
   return skb->len;
};

static struct packet_type test_proto = {
   __constant_htons( ETH_P_ALL ),
   NULL,
   test_pack_rcv,
   (void*)1,
   NULL
};

static int __init my_init( void ) {
   dev_add_pack( &test_proto );
   printk( KERN_INFO "module loaded\n" );
   return 0; 
}

static void __exit my_exit( void ) {
   dev_remove_pack( &test_proto );
   printk( KERN_INFO "module unloaded\n" );
}

module_init( my_init );
module_exit( my_exit );

MODULE_AUTHOR( "Oleg Groshev" );
MODULE_LICENSE( "GPL v2" );

